/*
CIFFOLD 0.5.1 Pre-Release
by Kostadin Mitev, Georgi Todorov and Herbert J. Bernstein

Copyright (C) Kostadin Mitev 2005

Work funded in part by the International Union of Crystallography under
a grant to Dowling College.

This software is covered by the GNU General Public License 
<see COPYING>.

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

 */

#include<iostream>
#include<string>
#include"ERROR.h"

using namespace  std;

int ERRORS[MAXERR][2]; 
int errcount = 0;

char * MESSAGE[] =
		   {"#_#ERROR: NAME TOO LONG",
		    "#_#ERROR: 2 ITEMS HAVE THE SAME NAME",
		    "#_#ERROR: VALUE EXPECTED BUT SOMETHING ELSE FOUND",
		    "#_#ERROR: NON-TERMINATED STRING",
		    "#_#ERROR: A TAG EXPECTED BUT VALUE FOUND",
		    "#_#ERROR: LINE TOO LONG",
		    "#_#WARNING: UNCOMMENTED PRESENCE OF global_/stop_ FOUND",
		    "#_#ERROR: DATA BLCOK WITH NO NAME",
		    "#_#ERROR: UNCOMMENTED PRESENCE OF loop_", 
		    "#_#WARNING: AMBIGUOUS STRING DELIMETER CHANGED TO AN ALTERNATIVE ONE(\' to \" or \" to \')",
		    "#_#WARNING: UNCOMMENTED PRESENCE OF save_ FOUND(probably the file is a dictionary file)", 
		    "#_#ERROR: THE NUMBER OF DATA ITEMS IN A LOOP ARE NOT A MULTIPLE OF THE NUMBER OF TAGS",
		    "#_#WARNING: USE OF A RESERVED CHARACTER(\"[\" , \"]\", \"_\", etc. ",
		    "#_#ERROR: SAVE FRAME NOT TERMINATED"
};
		    
void ERROR::genErr(int linenum, int errorcode)
{
	ERRORS[errcount][0] = errorcode;
	ERRORS[errcount][1] = linenum;
	errcount++;
}
void ERROR::printErr(FILE* outf, int printWarn, int printEr)
{
   for(int i = 0;i < errcount; i++)
   {
	if( ((MESSAGE[ERRORS[i][0]][3] == 'E') && (printEr)) || ((MESSAGE[ERRORS[i][0]][3] == 'W') && (printWarn)) ) {
		fprintf(outf, "%s at line %d\n", MESSAGE[ERRORS[i][0]], ERRORS[i][1]);
	}
   }	
}
void ERROR::printErr(){
	for(int i = 0; i < errcount; i++)
	{
		fprintf(stderr, "%s at line %d\n", (MESSAGE[ERRORS[i][0]] + 3), ERRORS[i][1]);
	}
}
