/*
CIFFOLD 0.5.4 Pre-Release
by Kostadin Mitev, Georgi Todorov and Herbert J. Bernstein

Copyright (C) Kostadin Mitev 2005

Work funded in part by the International Union of Crystallography under
a grant to Dowling College.

This software is covered by the GNU General Public License 
<see COPYING>.

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

 */

#include <iostream>
#include <cstring>
#include <fstream>
#include <sstream>
#define READFILE 
#include"ERROR.h"
#include"Globals.h"

 ERROR ERR;
 bool preserve;
 char *fileinmap;
 string lineMap;		//holds the map of the current line i.e. blanks and data
 int errorCount = 0;
 int nloop = -1;
 bool countitems = false;
 int textFieldCount = -1;
 char *TMPBUFF = new char[BUFSIZE]; 
 bool *STATE = new bool [7];     
   //0-datablock, 
   //1-save frame, 
   //2-loop, 
   //3-data value expected, 
   //4-data tags expected, 
   //5-comment, 
   //6-textfield starting with a semicolumn
   //errorcode: 
     //0- name too long , 
	 //1-2 items have the same name, 
	 //2- value expected but something else found, 
	 //3- Nonterminated string, 
	 //4-A tag expected but value found, 
	 //5- line is too long
     //6-Uncommented global_/stop_ 
	 //7- datablock with no namei 
	 //8- Uncommented appearance of loop_ 
	 //9- delimeters of "o"" chenged to the alternative 'o"' to avoid ambiguity 
	 //11- uncommented presence of save_, 
	 //12- the number of data is not a multiple of the tags, 
	 //13- Unquoted use of reserved chracter("[" of "]")
char*  ReadFile::read(char *filein, int Nitems, int lpformat, int isDictionary)
{
	index = 0;
	int linecnt = 0;
	int pos;
	int tooLong = 0;		//if 1 then the token is tooLong
	int errCode = -1;		//0-a data value expected but nothing found, 
	int nitems = 0;
	int ntags = 0;
	char terminator = ' ';
	int curLLength;
	int datModTag = 0; 		//Used to check whether the number of items in a loop is a multiplw of the number of tags
	char * curStr = new char [BUFSIZE];	
	char *BUFFER = new char [BUFSIZE];
	int Tblanks = 0;
	bool fatalError = false;
	bool notfirst = false;
	char *name = new char[BUFSIZE];
	char *tmp = new char[13];
		strncpy(tmp ,"/tmp/fXXXXXX", 13);
	preserve = true;	//make this equal to some parameter 
	int chk = mkstemp(tmp); //create tmp file to store the inputfile after the preformatting
	loop ll;
	set<string> DATAN;		//Holds the datanames
	set<string>NAMES; 		//holds tag names
	set<string>SAVEFRAMES;		//Holds the headers of save frames 
	set<string>::iterator iter;
	filebuf pinbuf;
	istream fin(&pinbuf);
	ofstream fout(tmp, ios::out);
	ofstream fmap;
	
	if(OPTIONS[13]){
		fileinmap = new char[13];
		strncpy(fileinmap, "/tmp/fXXXXXX", 13);
		mkstemp(fileinmap);
		fmap.open(fileinmap);
	}
//////////////////////////////////////////////////	
	
	static char* RESERVED[] = { "data_",
			 	   "save_",
			 	   "global_",
			 	   "stop_",
			 	   "loop_"
	};
	
	if (strcmp(filein,"-")) {
	pinbuf.open(filein,ios::in);
	if(!pinbuf.is_open()){
	   cerr<<"!ERROR:The file "<<filein<<" cannot be opened\n";
	   exit(1);
	} 
	} else {
	  fin.rdbuf(cin.rdbuf());
	}
	for(int i = 0; i < 7;i++)
	{
		STATE[i] = false;
	}
	
	while(!fin.eof()){
		if(errorCount >= 100){
			fatalError = true;
			break;
		}
		fin.getline(curStr, BUFSIZE);
	//if we should format according to the file mapping or create a map. If unfolding strip up the filemap at the end of the file and copy it to a tmpmap file
	//else if folding and there is already a map and a new one should be created just strip of the old one	
		if(OPTIONS[13]){
			if(!strncasecmp(curStr, "#_M#", 4)){
				if(!OPTIONS[1]){
					fmap.write((curStr + 4), (strlen(curStr) -4) );
					fmap.put('\n');
				}
				continue;
			}
		}
		if(notfirst){			//and look for end of file also probably
			//if folding and generate a map is chosen output the linemap in the map file
			if((OPTIONS[1]) & (OPTIONS[13]) ){
				fmap << lineMap;
				fmap.put('\n');
//				cout<<linecnt<< ": "<<lineMap<<endl;
				lineMap.erase(0, lineMap.length());
			}
		    fout.put('\n');
		}
		linecnt++;
		Tblanks = rmtblanks(curStr);
		if(strlen(curStr) > LMAXLEN){
			ERR.genErr(linecnt, 5);
		}
		
		for(pos= 0; curStr[pos] != '\0'; pos++){
		  rmLBl(curStr, pos, fout);
/////////////////////////////LOOP////////////////////////////////////////////	  	  
		  if(!strncasecmp((curStr + pos), RESERVED[4], 5)){
			if( (curStr[pos+5]) && (!isspace(curStr[pos + 5])) ){
				ERR.genErr(linecnt, 8);
				errorCount++;
			}
			else{	
				nloop++;
				loop p;
				lpinfo.push_back(p);
				lpinfo[nloop].ndata = 0;
				lpinfo[nloop].ntags = 0;
				lpinfo[nloop].format = false;
				lpinfo[nloop].colsize = NULL;
				STATE[2] = true;
		//If this loop marks the termination of a previous one check the previous for logical integrity		
				if(countitems){
			                if(lpinfo[nloop -1].ntags == 0) {	
						ERR.genErr(linecnt, 11);
					}
					else{
					       	datModTag = lpinfo[nloop -1].ndata % lpinfo[nloop -1].ntags;
						if(datModTag != 0){
							ERR.genErr(linecnt, 11);
						}
					}
				}											
				countitems = true;
				if(STATE[3]){
	               	      		 ERR.genErr(linecnt, 2);
					 errorCount++;
			 	}
			}
			terminator = ' ';
			iterate(curStr, pos, terminator, fout, fin, linecnt, MAXLENGTH);
			STATE[3] = false;       //tag expected
	   	}
///////////////////////////////DATA BLOCK HEADER ////////////////////////////////////////		  
		     else if(!strncasecmp((curStr + pos), RESERVED[0], 5)){
			STATE[2] = false;
			STATE[0] = true;
			NAMES.clear();
			SAVEFRAMES.clear();
			if(countitems){
		 	     countitems = false;
			     if(lpinfo[nloop].ntags == 0) {
				     ERR.genErr(linecnt, 11);
			     }
			     else {
				     datModTag = lpinfo[nloop -1].ndata % lpinfo[nloop -1].ntags;
				     if (datModTag != 0){
					     ERR.genErr(linecnt, 11);
				     }
			     }
			}
			if(STATE[3]){
			   ERR.genErr(linecnt, 2);
			   errorCount++;
			   STATE[3] = false;
			}
			tooLong = findName(curStr,fout,  pos, pos + 5,  name);
			if(isspace(name[0]) || (!name[0])){
				ERR.genErr(linecnt, 7);
				errorCount++;
			}
			else if(!tooLong){
				string nname = name;
				if(!DATAN.insert(nname).second){
				   ERR.genErr(linecnt, 1);
				   errorCount++;
				}
			}
			else{
			     ERR.genErr(linecnt, 0);
			     errorCount++;
			}
			//if the tag is longer than the maximum desired length then print an error message
		       if ((strlen(name) + 5) > MAXLENGTH){
		                 ERR.genErr(linecnt, 0);
				 errorCount++;
		       }
					
		     }
/////i//////////////////CHECK FOR APPEARANCE OF UNCOMMENTED stop_ and global_ ///////////////////////////////////////////////////////		     
		    else if( (!strncasecmp((curStr + pos), RESERVED[2], 5)) || (!strncasecmp((curStr + pos), RESERVED[3], 5)) ){
			    if(STATE[2]){
				STATE[2] = false;
				lpinfoInitColsize(nloop);
				lpinfo[nloop].ndata++;
			    }											
			    terminator = ' ';
			    ERR.genErr(linecnt, 6);
	//errorcode 6 respods to a warning  errorCount++;
			    iterate(curStr, pos, terminator, fout, fin, linecnt, MAXLENGTH);
		    }
/////////////////////////////////////////CHECK FOR A SAVE FRAME	////////////////////////////////////////////////////////	    
		    else if(!strncasecmp((curStr + pos), RESERVED[1], 5)){
			//   if(STATE[2]){
				     STATE[2] = false;
			//	     lpinfoInitColsize(nloop);
			//	     lpinfo[nloop].ndata++;
			//  }
			    if(isDictionary == 0){
				 ERR.genErr(linecnt, 10);
//erorrcode 10 is a warning			 errorCount++; 
			         if(countitems){
	                            countitems = false;
				    if(lpinfo[nloop].ntags == 0) {
				       ERR.genErr(linecnt, 11);
                                   }
				   else{
					   datModTag = lpinfo[nloop -1].ndata % lpinfo[nloop -1].ntags;
					   if(datModTag != 0){
					   	ERR.genErr(linecnt, 11);
					   }
				   }
			         }
			        terminator  = ' ';
			        if(STATE[3]){
			 	    ERR.genErr(linecnt, 2);
				    errorCount++;
		  	        }
			    }
	//The file is a dictionary file		    
			    else{
				 if( (STATE[1]) && (!isspace(curStr[pos + 5])) ){
				   ERR.genErr(linecnt, 13);
//probably terminate it automatically 	   
				  }
				  else{
				    tooLong = findName(curStr, fout, pos, pos + 5, name);
				    if(!tooLong){
					   string nname = name;
					   if(!SAVEFRAMES.insert(nname).second){
						   ERR.genErr(linecnt, 1);
						   errorCount++;
					   }
				    }
				    else{
					    ERR.genErr(linecnt, 0);
					    errorCount++;
				    }
				  }
			    }
				 
		    }
////////////////////////////////CHECK FOR A TAG///////////////////////////////////////////		    
		       else if((curStr[pos] == '_') && (!isspace(curStr[pos + 1])) ){
				 if(!STATE[2]){
					if(STATE[3]){
					   ERR.genErr(linecnt, 2);
					   errorCount++;
					}
					else{
					    STATE[3] = true;
					}
					if(countitems){
                             			countitems = false;
				                if(lpinfo[nloop].ntags == 0) {
					   	     ERR.genErr(linecnt, 11);
						}
						else{
							datModTag = lpinfo[nloop].ndata % lpinfo[nloop].ntags;
							if(datModTag != 0){
								ERR.genErr(linecnt, 11);
							}
						}
					}
				   }
				   else if(STATE[2]){
					lpinfo[nloop].ntags++;
					STATE[3] = true;
				   }
				   tooLong = findName(curStr, fout, pos, pos,  name);
				   if(!tooLong){
					string nname = name;
                                	if(! NAMES.insert(nname).second){
                                   		ERR.genErr(linecnt, 1);
						errorCount++;
                                	}
                        	   }
				   else{
					ERR.genErr(linecnt, 0);
					errorCount++;
				   }
				    //if the tag is longer than the maximum desired length then print an error message
		                   if ((strlen(name) + 5) > MAXLENGTH){
			printf("name is: %s\n", name); 
					ERR.genErr(linecnt, 0);  
					errorCount++;
				   }                                                                                                                

			}
////////////////////////EVERYTHING ELSE/////////////////////////////////////////////////		       
		 	else{		      
			    switch(curStr[pos]){
			     case('\''):{
				terminator = '\'';
				    if(countitems){
               			      if(STATE[2]){
                                          STATE[2] = false;
					  lpinfoInitColsize(nloop);
                                          if(!STATE[3]){
                                             ERR.genErr(linecnt, 4);
                                             countitems = false;
                                          }
					  else{
					     lpinfo[nloop].ndata++;
					  }
				       }
                                       else{
                                           lpinfo[nloop].ndata++;
                                       }
				     }
				     else if(!STATE[3]){
					   ERR.genErr(linecnt, 4);
					   errorCount++;
				     } 
				   STATE[3] = false;	   
				   break;
			     }
			     case('\"'):{
			     	terminator = '\"';
				  if(countitems){
				     if(STATE[2]){
					  STATE[2] = false;
					  lpinfoInitColsize(nloop);
					  if(!STATE[3]){
					     ERR.genErr(linecnt, 4);
					     countitems = false;
					  }
					  else{
					     lpinfo[nloop].ndata++;
					  }
				      }
				      else{
					   lpinfo[nloop].ndata++;
			   	      }
				  }
				  else if(!STATE[3]){
					  ERR.genErr(linecnt, 4);
					  errorCount++;
				  }
				  STATE[3] = false;
                                  break;
				}
				case('#'):{                  	  
				    terminator = '\n'; 
                                    break;
				}
				case(';'):{
				if(pos == 0){		  
				  terminator = ';';
				  textFieldCount++;
				    if(countitems){
					if(STATE[2]){
                                          STATE[2] = false;
					  lpinfoInitColsize(nloop);
                                          if(!STATE[3]){
                                             ERR.genErr(linecnt, 4);
                                             countitems = false;
                                          }
                                          else{
                                             lpinfo[nloop].ndata++;					     
                                          }
                                      }
                                      else{
                                           lpinfo[nloop].ndata++;
                                      }
				    }
				    else if(!STATE[3]){
					    ERR.genErr(linecnt, 4);
					    errorCount++;
				    }
				   STATE[3] = false;
				   break;
				} //if (pos == 0)
				}
				default:{
				  terminator = ' ';
				    if(countitems){
					 if(STATE[2]){
                                           STATE[2] = false;
					   lpinfoInitColsize(nloop);
                                           if(!STATE[3]){
                                              ERR.genErr(linecnt, 4);
                                              countitems = false;
                                           }
                                           else{
                                              lpinfo[nloop].ndata++;
                                           }
					 }
                                        else{
                                           lpinfo[nloop].ndata++;
                                        }
				    }
				    else if(!STATE[3]){
					    ERR.genErr(linecnt, 4);
					    errorCount++;
				    }
				    STATE[3] = false;
				    switch(curStr[pos])
				    {
					case('_'):{
                                		//same error as the next one
                             		}
                             		case(']'):{
                                		//same error as the next one
                             		}
                             		case ('['):{
                                  //terminator = ' ';
				  	     if(isspace(curStr[pos + 1])){
                                  		ERR.genErr(linecnt, 13);
					     }
                                   		break;
                             		}
				    }//switch
				 }
			  }//switch
			tooLong = iterate(curStr, pos, terminator, fout, fin, linecnt, MAXLENGTH);
			if(tooLong == -1){
				ERR.genErr(linecnt, 3);
				errorCount++;
			}
		       }//else
		}
		notfirst = true;
	}
	
/////TESTING//////
unsigned long int size = 0;
unsigned long int lastel = 0;
unsigned long int element = 0;
for ( long int g = lpinfo.size(); --g >= 0; )
{
	size = lpinfo[g].ntags;
	element = 0;
	//if the loop was incorrect and colsize was not initialized then initialize it 
	if(lpinfo[g].colsize == NULL){
		lpinfo[g].colsize = new unsigned long int[size + 1];
		lpinfo[g].colsize[size] = 0;
		continue;
	}
	lpinfo[g].colsize[size] = 0;				// used as a boolean 0-the formatting is not valid, 1-it is valid
	//if the loops are considered large and the oprtion format tersly large loops is set then set format to true
	if((lpformat) && ((getLoop(g)->ndata + size)  >= Nitems))
	{
		if(lpformat == 1){	
		  getLoop(g) ->format = true;
		}
	}
	//if no terse formatting of the loop is selected calculate the correct position of the columns
	//note that the length of the last data filed is stored at position 0(because of the mod used to calculate the array index the first is at 1 and so on
	if(!lpinfo[g].format){	
	   if(size > 1)	{	
		lastel = lpinfo[g].colsize[1];
		lpinfo[g].colsize[1] = 0;	//the position the first data item should statr from
		
		if(size > 2){
			for(unsigned long int y = 2; y < size; y++)
			{
				element = lpinfo[g].colsize[y];
				lpinfo[g].colsize[y] = lastel + 1;
				lastel += (element + 1);
			}
		}
		element = lpinfo[g].colsize[0];
		lpinfo[g].colsize[0] = lastel + 1;			
		if(lpinfo[g].colsize[0] + element <= MAXLENGTH){
			lpinfo[g].colsize[size] = 1;		//the formatting is valid
			//set the alignment correctly so the first column`s alignment 
			//appears at position 0 and the last at position size -1;	
			element = lpinfo[g].colsize[0];
			for(unsigned long int j = 0; j < size; j++)
			{
				lpinfo[g].colsize[j] = lpinfo[g].colsize[j + 1];
			}
			if(size > 1){
				lpinfo[g].colsize[size -1] = element;
			}
		}
	   }
	   else if(lpinfo[g].colsize[0] <= MAXLENGTH){
		lpinfo[g].colsize[1] = 1;
		lpinfo[g].colsize[0] = 0;
	   }
	}
	lpinfo[g].ndata--;			//convert to a zero based count
	 
}
	//close the files that have been opened
	if(fout){	
		fout.close();
	}
	if(fmap){
		fmap.close();	
	}
	//delete everything that has been allocated without tmp
        delete []BUFFER;
	delete []curStr;
	delete []name;

	if(fatalError){
		printf("FATAL ERROR OCCURED PROCESSING FILE %s ABORTED\n", filein);
	     	ERR.printErr();	
		return NULL;
	}
	return tmp;
}

//Finds the name of a particular data
int ReadFile::findName(char *curLine, ofstream &fout, int& pos, int start,  char *name)
{
	int ii = 0;
	int ret = 0;
	//if a map should be generated for exact reproduction of the file.
	if( (OPTIONS[1]) && (OPTIONS[13]) ){
		lineMap += "d";
	}
	
	for(int i = pos; i < strlen(curLine);i++)
	{
		if(! isspace(curLine[i])){
			if(i >= start){		
			name[ii++] = curLine[i];
		}
		fout.put(curLine[pos++]);
	   }
	   else{
		 break;
	   }
	}
	name[ii] = '\0';
	if(strlen(name) > 75){
		ret = 1;
	}
	--pos;
	return ret;
}
//Write the data to a tmp file 
int ReadFile::iterate(char *& curLine, int& pos, char terminator, ofstream &fout, istream &fin, int& linecnt, int maxlen)
{
	
    int k = -1;
    unsigned long int cnt = 0;		//the length of the token
    int initial = pos;		//the position from where the token begins
    int coln = 0;		//the column of the loop tag
    int advance = 0;
    bool first = true;
    bool formatText = false;
	bool foldedText = false;
	bool foldedLast = false;
    //if a map should be generated for exact reproduction of the file
    if( (OPTIONS[1]) && (OPTIONS[13]) ){	
   	 lineMap += "d";
    }
   //If in a loop and this is a data item find the correct column(coln) the length of the token should be stored 
    if((countitems) && (!STATE[2])){
	    if(lpinfo[nloop].ntags > 0){
	    	coln = lpinfo[nloop].ndata % lpinfo[nloop].ntags;
	    }
    }
//if a comment
    if(terminator == '\n'){
	    k = 1;
	    fout.write((curLine + pos), (strlen(curLine) - pos));
	    pos = strlen(curLine) -1;
    }
//if a text field
    else if(terminator == ';'){
	    if( (OPTIONS[1]) && (OPTIONS[13]) ){
	    		lineMap += terminator;	//insert the appropriate delimeter
	    }
	    //perform length check of the text field we check against maxlen + 1 to exclude the delimiter form the length
	    if(strlen(curLine) > maxlen){	
		    formatText = true;
	    }
	    //output the first line and start looping from the second looking for the closing tag
	    fout.write(curLine, strlen(curLine));
		foldedText = false;
		foldedLast = false;
		if ((!strncmp(curLine,";\\",2)) && (strlen(curLine)==2)) {
		  foldedText = true;
		  foldedLast = true;
		}
		while(fin.getline(curLine, BUFSIZE))
	    { int lcurLine;
		  rmtblanks(curLine);
		  lcurLine = strlen(curLine);
		  fout.write("\n", 1);
		  linecnt++;  
		  if( (curLine[0] == terminator) && ((!curLine[1]) || (isspace(curLine[1]))) ){
			  k = 1;			//closing tag is found
			  pos = 0;
			  fout.write(curLine, 1);	//output the closing tag
			  break;
		  }
		  else{
			  //perform length check for options[10]
			  if(lcurLine > maxlen){
				  formatText = true;
			  }
			  foldedLast = false;
			  fout.write(curLine, lcurLine);
			  if (foldedText && lcurLine > 0 && curLine[lcurLine-1] == '\\') foldedLast = true;
		  }
		    
	    }
	 //   rmtblanks(curLine);
	    if(k != 1){
		    pos = strlen(curLine) -1;
	    } 
	FORMATTEXT.push_back(formatText);	//store formatText for later lookup if options[10] is set
	FOLDEDTEXT.push_back(foldedText);   //note any folded text fields
	FOLDEDLAST.push_back(foldedLast);	//note any folded text fields with a folded last line  
    }//if(terminator == ';')
  //else if delimited string  
    else if((terminator == '\'') || (terminator == '\"')){
	    if( (OPTIONS[1]) && (OPTIONS[13]) ){
	    	lineMap += terminator;
	    }
	    //put the opening delimeter in the buffer and continue looking for the closing one
	    TMPBUFF[cnt] = curLine[pos];
	    cnt++;
	    pos++;
	    while(curLine[pos])
	    {
		    TMPBUFF[cnt] = curLine[pos];
		    cnt++;
		    if( (curLine[pos] == terminator) && ((!curLine[pos + 1]) || (isspace(curLine[pos+1]))) ){
			 k = 1;		//the closing tag is found
			 break;	 
		    }
		    pos++;   
	    }
	    //if the closing tag is found check for ambiguous delimters and change them if found
	    if(k == 1 ){
                 if(terminator == '\''){
                         if( ((TMPBUFF[1] == terminator) || (TMPBUFF[cnt-2] == terminator)) && ((TMPBUFF[1] != '\"') && (TMPBUFF[cnt-2] != '\"')) ){
//ERR.genErr(linecnt, 9);
//errorcode 9 coresponds to a warning                            errorCount++;
                                 TMPBUFF[0] = '\"';
                                 TMPBUFF[cnt-1] = '\"';
                         }
                 }
                else if(terminator == '\"'){
                        if( ((TMPBUFF[1] == terminator) || (TMPBUFF[cnt-2])== terminator) && ((TMPBUFF[1] != '\'') && (TMPBUFF[cnt-2] != '\'')) ){
// ERR.genErr(linecnt, 9);
//errorcode 9 coresponds to a warning                            errorCount++;
                                 TMPBUFF[0] = '\'';
                                 TMPBUFF[cnt-1] = '\'';
                        }
                                                                                                                                                                                                     
                }
            }
	    fout.write(TMPBUFF, cnt);
	    
    }//else if(terminator == '\'') ....
    //everything else is just terminated by a white space or a new line
    else{
	    k = 1;		//there is no closing tag 
	    TMPBUFF[cnt] = curLine[pos];
	    cnt++;
	    pos++;
	    while(curLine[pos])
	    {
		   if(isspace(curLine[pos])){
		        break;
		   }
		   TMPBUFF[cnt] = curLine[pos];
		   cnt++;
		   pos++;
	    }
	    fout.write(TMPBUFF, cnt);
 	    pos--;	    
    }
    //if not a comment or a textfield and in a loop`s data block adjust the size of the column
    if( ((countitems) && (!STATE[2])) && (terminator != ';') && (terminator != '\n') ){
	   if( (cnt < maxlen) && (cnt > lpinfo[nloop].colsize[coln]) ){
		  lpinfo[nloop].colsize[coln] = cnt;
	   }
    }
    return k;
}

loop* ReadFile::getLoop(int idx)
{
   if(idx >= lpinfo.size()){
     return &loopNull;
    }
   return   &lpinfo[idx];
}
int ReadFile::rmLBl(char *curStr, int& pos, ofstream& fout)
{
	int k = 0;
	long ntabs = 0;		//count the number of sequential tabs 
	long nblanks = 0;	//count the number of sequential blanks(evrery blanks except horizontal tab)
	
	if(isspace(curStr[pos])){
		for( ;isspace(curStr[pos]); pos++)
		{
		    if( (OPTIONS[1]) && (OPTIONS[13]) ){
			if(curStr[pos] == '\t'){
				if(nblanks > 0){
					lineMap += "s";
					lineMap += convertToStr(nblanks);
					nblanks = 0;
				}
				ntabs++;
			}
			else {
			     if(ntabs){
				lineMap += "t";
				lineMap += convertToStr(ntabs);
				ntabs = 0;
			     }
			     nblanks++;
			}	
		    }	
		    fout.put(curStr[pos]);
		}
	}
	if( (OPTIONS[1]) && (OPTIONS[13]) ){
		if(ntabs){
			lineMap += "t";
			lineMap += convertToStr(ntabs);
			ntabs = 0;
		}
		else if(nblanks){
			lineMap += "s";
			lineMap += convertToStr(nblanks);
			nblanks = 0;
		}
	}
	return 0;
}
void ReadFile::lpinfoInitColsize(int position)
{
	unsigned long int size = lpinfo[position].ntags;

	lpinfo[position].colsize = new unsigned long int [size + 1];     //The last value will show whethter the aligning is valid or no
	for(unsigned long int i = 0; i < size;i++)
	{
		lpinfo[position].colsize[i] = 0;
	}
}
void ReadFile::printErr(FILE *filename, int printWarn, int printEr){
	ERR.printErr(filename, printWarn, printEr);
}
void ReadFile::printErr(){
	ERR.printErr();
}
char *ReadFile::getMapfilename()
{
	return fileinmap;
}
string ReadFile::convertToStr(int i)
{
	ostringstream ss;
	string failed = "CF";	//CF stand for conversion failed
	
	if(ss<< i){
		return ss.str();
	}
    return failed;
}
ReadFile::~ReadFile()
{
	unsigned long int size = lpinfo.size();
	delete [] STATE;
	for(unsigned long int i = 0; i < size; i++)
	{
		delete [] lpinfo[i].colsize; 
	}

}
